<?php
ini_set('display_startup_errors',1);
ini_set('display_errors',1);
error_reporting(-1);
require('../../config.php');

defined('MOODLE_INTERNAL') || die();
global $DB;
if (isloggedin() && (is_siteadmin())) {
   $sql = "select id,fullname from mdl_course where id > 5";
   foreach ($DB->get_records_sql($sql) as $result) {
      $id = $result->id;
      $cname = $result->fullname;
      echo '<br> Resetting Course '.$cname;
      reset_bcln_userdata($id);   
    }   
    echo 'done';
} else {
    echo 'You must be logged in as ad admin to run this';
}
exit();
function reset_bcln_userdata($cid) {
    global $CFG, $DB;
    require_once($CFG->libdir.'/gradelib.php');
    require_once($CFG->libdir.'/completionlib.php');
    require_once($CFG->dirroot.'/completion/criteria/completion_criteria_date.php');
    require_once($CFG->dirroot.'/group/lib.php');

//    $data->courseid = $cid;
    $context = context_course::instance($cid);

   
    // Calculate the time shift of dates.
   
    // Result array: component, item, error.
    $status = array();

    // Start the resetting.
    $componentstr = get_string('general');

    // Move the course start time.
    if (!empty($data->reset_start_date) and $data->timeshift) {
        // Change course start data.
        $DB->set_field('course', 'startdate', $data->reset_start_date, array('id' => $data->courseid));
        // Update all course and group events - do not move activity events.
        $updatesql = "UPDATE {event}
                         SET timestart = timestart + ?
                       WHERE courseid=? AND instance=0";
        $DB->execute($updatesql, array($data->timeshift, $data->courseid));

        // Update any date activity restrictions.
        if ($CFG->enableavailability) {
            \availability_date\condition::update_all_dates($data->courseid, $data->timeshift);
        }

        // Update completion expected dates.
        if ($CFG->enablecompletion) {
            $modinfo = get_fast_modinfo($data->courseid);
            $changed = false;
            foreach ($modinfo->get_cms() as $cm) {
                if ($cm->completion && !empty($cm->completionexpected)) {
                    $DB->set_field('course_modules', 'completionexpected', $cm->completionexpected + $data->timeshift,
                        array('id' => $cm->id));
                    $changed = true;
                }
            }

            // Clear course cache if changes made.
            if ($changed) {
                rebuild_course_cache($cid, true);
            }

            // Update course date completion criteria.
            \completion_criteria_date::update_date($data->courseid, $data->timeshift);
        }

        $status[] = array('component' => $componentstr, 'item' => get_string('datechanged'), 'error' => false);
    }

    $DB->delete_records('event', array('courseid' => $cid));
    $status[] = array('component' => $componentstr, 'item' => get_string('deleteevents', 'calendar'), 'error' => false);
    

    require_once($CFG->dirroot.'/notes/lib.php');
    note_delete_all($cid);
    
    require_once($CFG->dirroot.'/blog/lib.php');
    blog_remove_associations_for_course($cid);
    
    // Delete course and activity completion information.
    $course = $DB->get_record('course', array('id' => $cid));
    $cc = new completion_info($course);
    $cc->delete_all_completion_data();
    
    \core_competency\api::hook_course_reset_competency_ratings($cid);
    
    $componentstr = get_string('roles');

    
    // First unenrol users - this cleans some of related user data too, such as forum subscriptions, tracking, etc.
    $plugins = enrol_get_plugins(true);
    $instances = enrol_get_instances($cid, true);
    foreach ($instances as $key => $instance) {
        if (!isset($plugins[$instance->enrol])) {
            unset($instances[$key]);
            continue;
        }
    }

    $withroleid =5;
    $sql = "SELECT ue.*
                          FROM {user_enrolments} ue
                          JOIN {enrol} e ON (e.id = ue.enrolid AND e.courseid = :courseid)
                          JOIN {context} c ON (c.contextlevel = :courselevel AND c.instanceid = e.courseid)
                          JOIN {role_assignments} ra ON (ra.contextid = c.id AND ra.roleid = :roleid AND ra.userid = ue.userid)";
    $params = array('courseid' => $cid, 'roleid' => $withroleid, 'courselevel' => CONTEXT_COURSE);

    $rs = $DB->get_recordset_sql($sql, $params);
    foreach ($rs as $ue) {
       if (!isset($instances[$ue->enrolid])) {
            continue;
       }
       $instance = $instances[$ue->enrolid];
       $plugin = $plugins[$instance->enrol];
       if (!$plugin->allow_unenrol($instance) and !$plugin->allow_unenrol_user($instance, $ue)) {
           continue;
       }

       $plugin->unenrol_user($instance, $ue->userid);
       $data->unenrolled[$ue->userid] = $ue->userid;
    }
    $rs->close();
        
    
    
    $data->courseid=$cid;
    $data->reset_forum_all = 'TRUE';
    $data->reset_quiz_attempts = 'TRUE';
    $data->reset_assign_submissions = 'TRUE';
    $data->reset_chat = 'TRUE';
    $data->reset_data = 'TRUE';
    $data->reset_glossary_all = 'TRUE';
    $data->reset_lesson = 'TRUE';
    $data->reset_scorm = 'TRUE';
   // $data->reset_gradebook_grades = 'TRUE';
   // $data->reset_gradebook_items = null;
    
    // Look in every instance of every module for data to delete.
    $unsupportedmods = array();
    if ($allmods = $DB->get_records('modules') ) {
        foreach ($allmods as $mod) {
            $modname = $mod->name;
            $modfile = $CFG->dirroot.'/mod/'. $modname.'/lib.php';
            $moddeleteuserdata = $modname.'_reset_userdata';   // Function to delete user data.
            if (file_exists($modfile)) {
                if (!$DB->count_records($modname, array('course' => $cid))) {
                    continue; // Skip mods with no instances.
                }
                include_once($modfile);
                if (function_exists($moddeleteuserdata)) {
                    $modstatus = $moddeleteuserdata($data);
                    if (is_array($modstatus)) {
                        $status = array_merge($status, $modstatus);
                    } else {
                        echo('Module '.$modname.' returned incorrect staus - must be an array!');
                    }
                } else {
                    $unsupportedmods[] = $mod;
                }
            } else {
                echo('Missing lib.php in '.$modname.' module!');
            }
        }
    }

    

     //remove_course_grades($cid, false);
    grade_course_reset($cid);
     grade_grab_course_grades($cid);
     grade_regrade_final_grades($cid);
    // Reset comments.
    require_once($CFG->dirroot.'/comment/lib.php');
    comment::reset_course_page_comments($context);
    

    return 0;

}
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

